//+------------------------------------------------------------------+
//|                                                     Trending.mq4 |
//|                                                       Matheszabi |
//|                                         https://www.mathesoft.ro |
//+------------------------------------------------------------------+
#property copyright "Matheszabi"
#property link      "https://www.mathesoft.ro"
#property version   "4.00"
#property strict
//-- indicator settings:
#property indicator_chart_window
#property  indicator_buffers 11

#property  indicator_color1  Red            // HH line , filtered Signal
#property  indicator_color2  MediumBlue     // LL line , filtered signal
#property  indicator_color3  Orchid         // HL line 
#property  indicator_color4  RoyalBlue      // LH line 

#property  indicator_color5  Orange         // Market / Trade Open - Close time
#property  indicator_color6  Yellow         // News Bomb


#property  indicator_color7   Pink     // HH square Quantum
#property  indicator_color8   Aqua     // LL square Quantum
#property  indicator_color9   Red      // HH filtered fignal
#property  indicator_color10  Blue     // LL filtered signal
//-- buffers:

double ExtBufferHH[];//line
double ExtBufferLL[];//line
double ExtBufferHL[];//line
double ExtBufferLH[];//line
double ExtBufferOpenTime[]; // Market/Period open
double ExtBufferCloseTime[]; // Market / Period close
double ExtBufferNewsTime[]; // News: EUR, GBP, USD news time release
double ExtBufferHHClose[]; // Quantum signal unfiltered
double ExtBufferLLClose[]; // Quantum signal untilfered
double ExtBufferSignalHHShort[]; // Short Enter Signal
double ExtBufferSignalLLLong[]; // Long Entry Signal
//double ExtBufferStop[]; // 
//double ExtBufferCheck[]; // 
//-- input:
extern int PERIOD_HH = 200;
extern int PERIOD_LL = 200;
extern int PERIOD_HL = 25;
extern int PERIOD_LH = 25;
extern bool ShowTextHH = true;
extern bool ShowTextLL = true;
extern bool ShowTextHL = true;
extern bool ShowTextLH = true;
extern bool ShowOpenCloseTime = true;
extern string OpenTime = "0:00";
extern string CloseTime = "8:00";
extern bool ShowNewsTime = true;      
extern string NewsReleaseTimesComaSeparatred = "8:00, 8:30, 12:30, 14:00, 14:30, 18:00";
//--                                           11:00 11:30  15:30  17:00  17:30  21:00
//--                                            EUR   GBP   USD1!  USD2    CAD   FOCM 
extern bool ShowQuantum = true;
extern bool FilterByEntryPip = true;
extern int EntryMinPipDifference = 10;


extern bool ShowTradeSignals = true;
// Stochastic Main > 80 %% Signal < 80, trend just started, high spike
// Stochastic Main > 95 % Signal > 95 , trend has more power.
//  Stochastic Main 80-95 && Signal 80-95 maybe counter trend

// -- helpers
int maxPeriod;
int openMinutes, closeMinutes;
int newsTimeMinutes[]; // additional array allocated, needs to be free at the end
int newsTimeMinutesSize;
MqlDateTime timeStruct;

// USD based Point: 1e-005 Digits 5
// JPY based Point: 0.001  Digits 3
double PriceToPipMultiplier = MathPow(10, Digits-1);


double lastShortEntryPrice = 0.0;
double lastLongEntryPrice = 0.0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
	maxPeriod = MathMax(MathMax(MathMax(PERIOD_HH, PERIOD_LL),PERIOD_HL ),PERIOD_LH) ;
	//--- indicator buffers mapping   	  
	SetIndexBuffer(0,  ExtBufferHH);
	SetIndexBuffer(1,  ExtBufferLL);
	SetIndexBuffer(2,  ExtBufferHL);
	SetIndexBuffer(3,  ExtBufferLH);
	SetIndexBuffer(4,  ExtBufferOpenTime);
	SetIndexBuffer(5,  ExtBufferCloseTime);  
	SetIndexBuffer(6,  ExtBufferNewsTime); 
	SetIndexBuffer(7,  ExtBufferHHClose); // Quantum signal unfiltered
	SetIndexBuffer(8,  ExtBufferLLClose);  // Quantum signal unfiltered
	SetIndexBuffer(9,  ExtBufferSignalHHShort); // Short Enter Signal filtered
	SetIndexBuffer(10, ExtBufferSignalLLLong);  // Long Entry Signal filtered 
	//SetIndexBuffer(11, ExtBufferStop);
	//SetIndexBuffer(12, ExtBufferCheck);
	
	
#property  indicator_color1  DeepPink       // HH
#property  indicator_color2  MediumBlue     // LL
#property  indicator_color3  LightPink      // HL
#property  indicator_color4  RoyalBlue      // LH

#property  indicator_color5  Orange         // Market / Trade Open - Close time
#property  indicator_color6  Black          // News Bomb

	
	SetIndexStyle(0,  DRAW_LINE,  STYLE_SOLID, 2, indicator_color1); // HH line
	SetIndexStyle(1,  DRAW_LINE,  STYLE_SOLID, 2, indicator_color2); // LL line	
	SetIndexStyle(2,  DRAW_LINE,  STYLE_DOT,   1, indicator_color3); // HL line   
	SetIndexStyle(3,  DRAW_LINE,  STYLE_DOT,   1, indicator_color4); // LH line
	
	SetIndexStyle(4,  DRAW_ARROW, STYLE_SOLID, 5, indicator_color5);// Open
	SetIndexStyle(5,  DRAW_ARROW, STYLE_SOLID, 5, indicator_color5);// Close
	
	SetIndexStyle(6,  DRAW_ARROW, STYLE_SOLID, 1, indicator_color6); // News
	
	SetIndexStyle(7,  DRAW_ARROW, STYLE_DOT,   4, indicator_color7); // HH square
	SetIndexStyle(8,  DRAW_ARROW, STYLE_DOT,   4, indicator_color8); // LL square
	SetIndexStyle(9,  DRAW_ARROW, STYLE_DOT,   5, indicator_color9); // Quantum signal - filtered
	SetIndexStyle(10, DRAW_ARROW, STYLE_DOT,   5, indicator_color10); // Quantum signal - filtered
	//SetIndexStyle(11, DRAW_ARROW, STYLE_SOLID, 5, Red);// stop
	//SetIndexStyle(12, DRAW_ARROW, STYLE_SOLID, 5, Green);// check
	
	SetIndexDrawBegin(0, maxPeriod);
	SetIndexDrawBegin(1, maxPeriod); 
	SetIndexDrawBegin(2, maxPeriod);
	SetIndexDrawBegin(3, maxPeriod);

	SetIndexArrow(4, 240);// Arrow Left
	SetIndexArrow(5, 239);// Arrow Right
	SetIndexArrow(6,  77);// Bomb
	SetIndexArrow(7, 250);// Square HH
	SetIndexArrow(8, 250);// Square LL
	SetIndexArrow(9, 218);// Short HH
	SetIndexArrow(10, 217);// Long LL	
	//SetIndexArrow(11, SYMBOL_STOPSIGN);
	//SetIndexArrow(12, SYMBOL_CHECKSIGN);
	
	
	datetime openTime = StringToTime(OpenTime);
	datetime closeTime = StringToTime(CloseTime);	
	
	TimeToStruct(openTime, timeStruct);
	openMinutes = timeStruct.hour * 60 + timeStruct.min;
	TimeToStruct(closeTime, timeStruct);
	closeMinutes = timeStruct.hour * 60 + timeStruct.min;
	
	if(ShowNewsTime){
		string sep=",";
		ushort u_sep;              
		//--- Get the separator code
		u_sep = StringGetCharacter(sep,0);
		string result[];
		//--- Split the string to substrings
		int k = StringSplit(NewsReleaseTimesComaSeparatred,u_sep,result);
		newsTimeMinutesSize = k;
		ArrayResize(newsTimeMinutes, k);
		for(int i=0; i <k; i++){
			datetime curTime =  StringToTime(result[i]);
			TimeToStruct(curTime, timeStruct);
			newsTimeMinutes[i] = timeStruct.hour * 60 + timeStruct.min;		    
		} 
		ArrayFree(result);
	}
	string indName = "Trending ( HH: "+IntegerToString(PERIOD_HH, 0)+ ", LL: "+IntegerToString(PERIOD_LL, 0)+", HL: "+IntegerToString(PERIOD_HL, 0)+", LH: "+IntegerToString(PERIOD_LH, 0)+ " )";
	IndicatorShortName( indName );
	//Comment(Digits());
	

	//---
	return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
const int prev_calculated,
const datetime &time[],
const double &open[],
const double &high[],
const double &low[],
const double &close[],
const long &tick_volume[],
const long &volume[],
const int &spread[])
{
	//--- MT4 only saves open/high/low/close, all of Bid and only for the current chart.
	// accessing spread array will crash this codeat my broker
	int i;
	int limit = rates_total - prev_calculated;
	int curMinutes;
	int indexHH, indexLL;
	//--- check for rates total:   
	if(rates_total <= maxPeriod){
		return(0);
	}
	//--- last counted bar will be recounted
	if(prev_calculated>0)
	{
		limit++;
	}
	// the candle is at opening time
	for(i=limit-1; i>=0  && !IsStopped(); i--){
		//-- reset
		ExtBufferHH[i] = EMPTY_VALUE;
		ExtBufferLL[i] = EMPTY_VALUE;
		ExtBufferHL[i] = EMPTY_VALUE;
		ExtBufferLH[i] = EMPTY_VALUE;
		ExtBufferOpenTime[i] = EMPTY_VALUE;
		ExtBufferCloseTime[i] = EMPTY_VALUE;
		ExtBufferNewsTime[i] = EMPTY_VALUE;
		ExtBufferHHClose[i] = EMPTY_VALUE;
		ExtBufferLLClose[i] = EMPTY_VALUE;
		ExtBufferSignalHHShort[i] = EMPTY_VALUE;
		ExtBufferSignalLLLong[i] = EMPTY_VALUE;
		
		//-- calc
		indexHH = iHighest( Symbol(), Period(), MODE_HIGH, PERIOD_HH, i );
		indexLL = iLowest( Symbol(), Period(), MODE_LOW, PERIOD_LL, i );
		ExtBufferHH[i] = High[indexHH];//HH  line
		ExtBufferLL[i] = Low[indexLL]; //LL line
		
		if( indexHH == i){
			if(ShowQuantum){
				ExtBufferHHClose[i] = Close[i]; //action taken maybe on next candle opening
			}
			checkNewHH(i);// filtered signal		    
		}		
		if( indexLL == i){
			if(ShowQuantum){
				ExtBufferLLClose[i] = Close[i]; // action taken maybe on next candle opening
			}
			checkNewLL(i);	// filtered signal		    	    
		}
		
		ExtBufferLH[i] = Low[iLowest( Symbol(), Period(), MODE_HIGH, PERIOD_LH, i )];
		ExtBufferHL[i] = High[ iHighest( Symbol(), Period(), MODE_LOW, PERIOD_HL, i )];
		
		if(ShowOpenCloseTime){
			TimeToStruct(time[i], timeStruct);
			curMinutes =  timeStruct.hour * 60 + timeStruct.min;
			
			if(openMinutes == curMinutes){
				ExtBufferOpenTime[i] = Open[i];
			}
			if(closeMinutes == curMinutes){
				ExtBufferCloseTime[i] = Open[i];
			}
		}
		
		if(ShowNewsTime){
			TimeToStruct(time[i], timeStruct);
			curMinutes =  timeStruct.hour * 60 + timeStruct.min;
			for(int j=0; j<newsTimeMinutesSize; j++)
			{
				if(newsTimeMinutes[j] == curMinutes){
					ExtBufferNewsTime[i] = Open[i];
				}
			}
		}
		if(i==0){
			showLabelsForLines();
		}
		
		


	}     
	//--- return value of prev_calculated for next call
	return(rates_total);
}
//+------------------------------------------------------------------+


void checkNewHH(int indexNewHH){
	bool bypassFilterByEntryPip = false;
	if(FilterByEntryPip && indexNewHH > 0){//must be a closed candle
		if(lastShortEntryPrice > 0){
			double spreadPrice = MathAbs(Bid-Ask); 
			double priceDiff = lastShortEntryPrice - Close[indexNewHH]; 
			double priceDiffPip = priceDiff * PriceToPipMultiplier;	        
			// -- must be now a lower price:
			if(EntryMinPipDifference >= 0 && priceDiffPip < 0 && -priceDiffPip >= EntryMinPipDifference){  
				bypassFilterByEntryPip = true;;
			}
		}
		else{
			bypassFilterByEntryPip = true;;
		}
		if(bypassFilterByEntryPip){
			// short it:
			lastShortEntryPrice = Close[indexNewHH];// the new candle Open price
			if(ShowTradeSignals){
				ExtBufferSignalHHShort[indexNewHH] = lastShortEntryPrice;
			}
			lastLongEntryPrice = 0;
		}
	}
}

void checkNewLL(int indexNewLL){
	bool bypassFilterByEntryPip = false;
	if(FilterByEntryPip && indexNewLL > 0){//must be a closed candle
		if(lastLongEntryPrice > 0){
			double spreadPrice = MathAbs(Bid-Ask); 
			double priceDiff = lastLongEntryPrice - Close[indexNewLL]; 
			double priceDiffPip = priceDiff * PriceToPipMultiplier;	        
			// -- must be now a lower price:
			if(EntryMinPipDifference >= 0 && priceDiffPip > 0 && priceDiffPip >= EntryMinPipDifference){  
				bypassFilterByEntryPip = true;  
			}
		}
		else{
			bypassFilterByEntryPip = true;;
		}	    
		if(
				(!FilterByEntryPip || (FilterByEntryPip &&bypassFilterByEntryPip) )
				){
			// long it:
			lastLongEntryPrice = Close[indexNewLL];// the new candle Open price
			if(ShowTradeSignals){
				ExtBufferSignalLLLong[indexNewLL] = lastLongEntryPrice;
			}
			lastShortEntryPrice = 0;
		}
	} 
}


void showLabelsForLines()
{    

	string name;
	int digits = Digits();
	
	if(ShowTextHH){            
		name = "TextHH";
		if(ObjectFind(name) != -1) {
			ObjectDelete(name);
		}
		ObjectCreate(name, OBJ_TEXT, 0, 0, 0, 0, 0);
		ObjectSetText(name, "HH: "+ DoubleToStr(ExtBufferHH[0], digits) +", period: "+IntegerToString(PERIOD_HH,0) );
		ObjectSet(name, OBJPROP_COLOR, indicator_color1);
		ObjectSet(name, OBJPROP_TIME1, Time[0]);
		ObjectSet(name, OBJPROP_PRICE1, ExtBufferHH[0]);
	}
	if(ShowTextLL){
		name = "TextLL";
		if(ObjectFind(name ) != -1) {
			ObjectDelete(name);
		}
		ObjectCreate(name, OBJ_TEXT, 0, 0, 0, 0, 0);
		ObjectSetText(name, "LL: "+ DoubleToStr(ExtBufferLL[0], digits) +", period: "+IntegerToString(PERIOD_LL,0) );
		ObjectSet(name, OBJPROP_COLOR, indicator_color2);
		ObjectSet(name, OBJPROP_TIME1, Time[0]);
		ObjectSet(name, OBJPROP_PRICE1, ExtBufferLL[0]);
	}
	if(ShowTextHL){
		name = "TextHL";
		if(ObjectFind(name ) != -1) {
			ObjectDelete(name);
		}
		ObjectCreate(name, OBJ_TEXT, 0, 0, 0, 0, 0);
		ObjectSetText(name, "HL: "+ DoubleToStr(ExtBufferHL[0], digits) +", period: "+IntegerToString(PERIOD_HL,0)  );
		ObjectSet(name, OBJPROP_COLOR, indicator_color3);
		ObjectSet(name, OBJPROP_TIME1, Time[0]);
		ObjectSet(name, OBJPROP_PRICE1, ExtBufferHL[0]);
	}
	if(ShowTextLH){
		name = "TextLH";
		if(ObjectFind(name ) != -1) {
			ObjectDelete(name);
		}
		ObjectCreate(name, OBJ_TEXT, 0, 0, 0, 0, 0);
		ObjectSetText(name, "LH: "+ DoubleToStr(ExtBufferLL[0], digits) +", period: "+IntegerToString(PERIOD_LH,0)  );
		ObjectSet(name, OBJPROP_COLOR, indicator_color4);
		ObjectSet(name, OBJPROP_TIME1, Time[0]);
		ObjectSet(name, OBJPROP_PRICE1, ExtBufferLH[0]);
	}
}

//+------------------------------------------------------------------+

void OnDeinit(const int reason)
{
	if(ShowNewsTime){
		ArrayFree(newsTimeMinutes);
	}
	string name;
	if(ShowTextHH){            
		name = "TextHH";
		if(ObjectFind(name) != -1) {
			ObjectDelete(name);
		};
	}
	if(ShowTextLL){
		name = "TextLL";
		if(ObjectFind(name ) != -1) {
			ObjectDelete(name);
		}
	}
	if(ShowTextHL){
		name = "TextHL";
		if(ObjectFind(name ) != -1) {
			ObjectDelete(name);
		}
	}
	if(ShowTextLH){
		name = "TextLH";
		if(ObjectFind(name ) != -1) {
			ObjectDelete(name);
		}
    }
}
